%define version 8.0.5
%define subrel  2
%define rel 1
%define prerel %{nil}

%if "%{prerel}" != "%{nil}"
%define lc_prerel %(echo %{prerel} | tr "A-Z" "a-z")
%define release %mkrel 1.%{lc_prerel}.%{rel}
%else
%define release %mkrel %{rel}
%endif

# exclude 3rd party library from dependencies scanning
%global __requires_exclude_from ^%{_datadir}/%{name}/3rdparty/
%global __provides_exclude_from ^%{_datadir}/%{name}/3rdparty/
# exclude remaining PHP dependencies as long as their usage is not proven
%global __requires_exclude pear\\(.*\\)
%define __jar_repack %{nil}

Summary:      Open personal cloud
Name:         owncloud
Version:      %{version}
Release:      %{release}
Source0:      http://download.owncloud.org/community/%{name}-%{version}%{?prerel}.tar.bz2
License:      AGPLv3
Group:        Monitoring
Url:          http://owncloud.org/
Requires:     apache-mod_php
Requires:     php-zip
Requires:     php-mbstring
Requires:     php-gd
Requires:     php-curl
Requires:     php-iconv
Recommends:   php-sqlite3 php-pdo_sqlite
BuildArch:    noarch

%description
A personal cloud server which runs on you personal server 
and enables accessing your data from everywhere and sharing 
with other people.

%prep
%setup -q -n %{name}

%install
mkdir -p %{buildroot}%{_datadir}/%{name}
cp -pr * %{buildroot}%{_datadir}/%{name}

rm -rf %{buildroot}%{_datadir}/%{name}/config
rm -f %{buildroot}%{_datadir}/%{name}/AUTHORS
rm -f %{buildroot}%{_datadir}/%{name}/COPYING-AGPL
rm -f %{buildroot}/.htaccess

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}
pushd %{buildroot}%{_datadir}/%{name}
ln -s ../../..%{_sysconfdir}/%{name} config
ln -s ../../..%{_localstatedir}/lib/%{name} data
popd

# make config and apps directory apache-writable
chmod 775 %{buildroot}%{_sysconfdir}/%{name}
chmod 775 %{buildroot}%{_datadir}/%{name}/apps

mkdir -p %{buildroot}%{webappconfdir}
cat > %{buildroot}%{webappconfdir}/%{name}.conf <<EOF
# %{name} configuration
Alias /%{name} %{_datadir}/%{name}

<Directory %{_datadir}/%{name}>
    <IfModule mod_authz_core.c>
        # Apache 2.4
        Require all granted
    </IfModule>
    <IfModule !mod_authz_core.c>
        # Apache 2.2
        Order allow,deny
        Allow from all
    </IfModule>

    AddDefaultCharset utf-8
    php_value upload_max_filesize 513M
    php_value post_max_size 513M
    php_value memory_limit 512M
    php_value mbstring.func_overload 0
    php_value always_populate_raw_post_data -1

    <IfModule mod_fcgid.c>
        <IfModule mod_setenvif.c>
            <IfModule mod_headers.c>
                SetEnvIfNoCase ^Authorization$ "(.+)" XAUTHORIZATION=$1
                RequestHeader set XAuthorization %{XAUTHORIZATION}e env=XAUTHORIZATION
            </IfModule>
        </IfModule>
    </IfModule>

    <IfModule mod_rewrite.c>
        RewriteEngine on
        RewriteBase /owncloud
        RewriteRule .* - [env=HTTP_AUTHORIZATION:%{HTTP:Authorization}]
        RewriteRule ^\.well-known/host-meta public.php?service=host-meta [QSA,L]
        RewriteRule ^\.well-known/host-meta\.json public.php?service=host-meta-json [QSA,L]
        RewriteRule ^\.well-known/carddav remote.php/carddav/ [R]
        RewriteRule ^\.well-known/caldav remote.php/caldav/ [R]
        RewriteRule ^apps/calendar/caldav\.php remote.php/caldav/ [QSA,L]
        RewriteRule ^apps/contacts/carddav\.php remote.php/carddav/ [QSA,L]
        RewriteRule ^remote/(.*) remote.php [QSA,L]
    </IfModule>
</Directory>

<Directory %{_datadir}/%{name}/data>
    <IfModule mod_authz_core.c>
        # Apache 2.4
        Require all denied
    </IfModule>
    <IfModule !mod_authz_core.c>
        # Apache 2.2
        Order Deny,Allow
        Deny from All
        Allow from None
    </IfModule>
</Directory>
EOF

cat > %{buildroot}%_datadir/%name/.htaccess <<EOF
# Version: %{version}
EOF

%pretrans
if [ -e %{_datadir}/%{name}/data -a ! -L %{_datadir}/%{name}/data ]; then
    mv %{_datadir}/%{name}/data %{_localstatedir}/lib/%{name}
    pushd %{_datadir}/%{name}
    ln -s ../../..%{_localstatedir}/lib/%{name} data
    popd
fi
if [ -e %{_datadir}/%{name}/config -a ! -L %{_datadir}/%{name}/config ]; then
    mv %{_datadir}/%{name}/config %{_sysconfdir}/%{name}
    pushd %{_datadir}/%{name}
    ln -s ../../..%{_sysconfdir}/%{name} config
    popd
fi

%files
%doc AUTHORS COPYING-AGPL config/config.sample.php
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/3rdparty
%{_datadir}/%{name}/core
%{_datadir}/%{name}/config
%{_datadir}/%{name}/data
%{_datadir}/%{name}/lib
%{_datadir}/%{name}/l10n
%{_datadir}/%{name}/occ
%{_datadir}/%{name}/ocs
%{_datadir}/%{name}/settings
%{_datadir}/%{name}/themes
%{_datadir}/%{name}/*.php
%{_datadir}/%{name}/db_structure.xml
%{_datadir}/%{name}/indie.json
%{_datadir}/%{name}/index.html
%{_datadir}/%{name}/robots.txt
%_datadir/%name/.htaccess
%attr(-,root,apache) %{_datadir}/%{name}/apps
%attr(-,root,apache) %{_sysconfdir}/%{name}
%attr(-,apache,apache) %{_localstatedir}/lib/%{name}
%config(noreplace) %{webappconfdir}/%{name}.conf


%changelog
* Tue Aug 04 2015 neoclust <neoclust> 8.0.5-1.2.mga5
+ Revision: 860939
- fix rewrite rules for well-known URLs (caldav/carddav and host-meta),
  to properly redirect under /owncloud ( blino )
- fix version in .htaccess ( blino )
- New version 8.0.5

* Tue May 05 2015 neoclust <neoclust> 8.0.3-1.mga5
+ Revision: 821264
- New version 8.0.3

* Thu Apr 23 2015 luigiwalser <luigiwalser> 7.0.5-2.mga5
+ Revision: 820613
- add patch from fedora to fix upstream issue #14843

* Thu Mar 19 2015 luigiwalser <luigiwalser> 7.0.5-1.mga5
+ Revision: 818973
- 7.0.5

* Wed Dec 10 2014 luigiwalser <luigiwalser> 7.0.4-1.mga5
+ Revision: 802583
- 7.0.4
- remove upstreamed patch

* Sat Dec 06 2014 blino <blino> 7.0.3-5.mga5
+ Revision: 801721
- add upstream patch (pr#12154, issue#12150) to fix syncing CalDAV

* Fri Nov 21 2014 blino <blino> 7.0.3-4.mga5
+ Revision: 798073
- add back recommends on php sqlite packages, to avoid having a nonfunctional setup after package installation

* Fri Nov 21 2014 blino <blino> 7.0.3-3.mga5
+ Revision: 798069
- fix incorrect test in pretrans

* Mon Nov 17 2014 luigiwalser <luigiwalser> 7.0.3-2.mga5
+ Revision: 797685
- test for previous existence before running pretrans scriplet code

* Sun Nov 16 2014 guillomovitch <guillomovitch> 7.0.3-1.mga5
+ Revision: 797597
- new version
- enforce FHS-compatible setup, with configuration and variable files in correct locations
- restrict apache-writable permissions to where it is actually needed
- remove bogus automatic dependencies
- remove redudant dependencies
- don't ship .htacess file, use standard apache configuration file instead
- spec file cleanup

* Wed Oct 15 2014 umeabot <umeabot> 7.0.2-4.mga5
+ Revision: 744579
- Second Mageia 5 Mass Rebuild

* Thu Oct 02 2014 tv <tv> 7.0.2-3.mga5
+ Revision: 734784
- rebuild for pear deps
- rebuild for pear deps

* Tue Sep 16 2014 umeabot <umeabot> 7.0.2-2.mga5
+ Revision: 683291
- Mageia 5 Mass Rebuild

  + tv <tv>
    - use %%global for req/prov exclude
    - autoconvert to new prov/req excludes
    - s/uggests:/Recommends:/

* Fri Sep 05 2014 luigiwalser <luigiwalser> 7.0.2-1.mga5
+ Revision: 672375
- 7.0.2

* Tue Aug 05 2014 blino <blino> 7.0.1-1.mga5
+ Revision: 659916
- 7.0.1

* Wed Jul 30 2014 blino <blino> 7.0.0-1.mga5
+ Revision: 658220
- 7.0.0 final

* Tue Jul 22 2014 blino <blino> 7.0.0-0.rc3.1.mga5
+ Revision: 655635
- 7.0.0 rc3

* Sat Jul 12 2014 blino <blino> 7.0.0-0.rc1.1.mga5
+ Revision: 651401
- 7.0.0 rc1

* Fri Jul 04 2014 neoclust <neoclust> 7.0.0-0.beta1.1.mga5
+ Revision: 643010
- New version 7.0.0Beta1

* Thu Jul 03 2014 blino <blino> 6.0.4-1.mga5
+ Revision: 642750
- 6.0.4
- do not suggest php-apc, it is crashy

* Wed Apr 30 2014 luigiwalser <luigiwalser> 6.0.3-1.mga5
+ Revision: 618995
- 6.0.3

* Sun Mar 02 2014 luigiwalser <luigiwalser> 6.0.2-1.mga5
+ Revision: 598644
- New version 6.0.2

* Sun Mar 02 2014 neoclust <neoclust> 6.0.1-1.mga5
+ Revision: 598629
- New version 6.0.1

* Wed Dec 11 2013 neoclust <neoclust> 6.0.0-1.mga4
+ Revision: 556329
- New version 6.0.0 Final

* Fri Nov 29 2013 neoclust <neoclust> 6.0.0-0.rc1.1.mga4
+ Revision: 554053
- New version 6.0 RC1

* Thu Nov 28 2013 neoclust <neoclust> 6.0.0-0.beta5.1.mga4
+ Revision: 553786
- New version 6.0Beta5

* Sat Nov 02 2013 neoclust <neoclust> 6.0.0-0.beta2.1.mga4
+ Revision: 549064
- New version 6.0.0beta2

* Thu Oct 24 2013 neoclust <neoclust> 6.0.0-0.alpha1.3.mga4
+ Revision: 546762
+ rebuild (emptylog)

* Mon Oct 21 2013 umeabot <umeabot> 6.0.0-0.alpha1.2.mga4
+ Revision: 540980
- Mageia 4 Mass Rebuild

* Thu Oct 10 2013 neoclust <neoclust> 6.0.0-0.alpha1.1.mga4
+ Revision: 494766
- Update to owncloud 6

* Mon Sep 30 2013 neoclust <neoclust> 5.0.11-1.mga4
+ Revision: 489536
- New version 5.0.11

* Tue Aug 13 2013 oden <oden> 5.0.10-1.mga4
+ Revision: 466156
- 5.0.10
- make it work with apache 2.2 and 2.4

* Wed Jul 17 2013 blino <blino> 5.0.9-1.mga4
+ Revision: 455150
- 5.0.9

* Sun Jul 14 2013 neoclust <neoclust> 5.0.8-2.mga4
+ Revision: 453944
- Fix owncloud conf file location ( mga #10275)

* Sat Jul 13 2013 blino <blino> 5.0.8-1.mga4
+ Revision: 453874
- 5.0.8

* Tue Jun 11 2013 neoclust <neoclust> 5.0.7-1.mga4
+ Revision: 441929
- New version

* Fri Jun 07 2013 blino <blino> 5.0.6-2.mga4
+ Revision: 440319
- suggest php-apc, owncloud is really slow without it

* Sat May 25 2013 neoclust <neoclust> 5.0.6-1.mga4
+ Revision: 426935
- New security fix release

* Mon Apr 22 2013 neoclust <neoclust> 5.0.5-1.mga3
+ Revision: 410963
- New release ( sec fixes )

* Sat Apr 13 2013 neoclust <neoclust> 5.0.4-1.mga3
+ Revision: 410053
- New version

* Fri Apr 05 2013 neoclust <neoclust> 5.0.3-1.mga3
+ Revision: 408354
- New version

* Tue Apr 02 2013 neoclust <neoclust> 5.0.2-1.mga3
+ Revision: 407319
- New version

* Wed Mar 20 2013 neoclust <neoclust> 5.0.0-1.mga3
+ Revision: 404149
- New version

  + zezinho <zezinho>
    - new version

* Mon Mar 18 2013 zezinho <zezinho> 4.5.6-3.mga3
+ Revision: 403914
- better default security for data directory

* Sun Feb 24 2013 neoclust <neoclust> 4.5.6-2.mga3
+ Revision: 400236
- Add php-iconv as requires ( mga #9171)

* Mon Jan 28 2013 neoclust <neoclust> 4.5.6-1.mga3
+ Revision: 392816
- New version

* Sun Jan 13 2013 umeabot <umeabot> 4.5.1-2.mga3
+ Revision: 362270
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Oct 24 2012 neoclust <neoclust> 4.5.1-1.mga3
+ Revision: 309644
- New version ( bug fix version )

* Thu Oct 18 2012 neoclust <neoclust> 4.5.0-1.mga3
+ Revision: 307958
- New version

* Mon Sep 24 2012 juancho <juancho> 4.0.5-2.mga3
+ Revision: 296998
- Added missing BR php-curl

* Wed Jul 25 2012 dmorgan <dmorgan> 4.0.5-1.mga3
+ Revision: 274139
- New version 4.0.5

* Mon Jul 23 2012 blino <blino> 4.0.4-4.mga3
+ Revision: 273670
- adapt conf file to apache 2.4

* Sun Jul 15 2012 blino <blino> 4.0.4-3.mga3
+ Revision: 271048
- suggest php-pdo_sqlite as well, both this one and php-sqlite3 seems to be required

* Sun Jul 15 2012 blino <blino> 4.0.4-2.mga3
+ Revision: 271043
- suggest php-sqlite3 instead of the deprecated php-pear-MDB2_Driver_sqlite
- require php-gd

* Sun Jul 15 2012 dmorgan <dmorgan> 4.0.4-1.mga3
+ Revision: 270869
- New version

* Wed Apr 25 2012 fwang <fwang> 3.0.2-1.mga2
+ Revision: 233182
- new version 3.0.2

* Tue Jan 31 2012 dmorgan <dmorgan> 3.0.0-1.mga2
+ Revision: 203600
- New version 3.0.0

* Sun Jan 08 2012 dmorgan <dmorgan> 3.0-0.1.alpha1.1.mga2
+ Revision: 193563
- New version 3.0 Alpha1

* Wed Nov 23 2011 dmorgan <dmorgan> 2.0.1-1.mga2
+ Revision: 171107
- New version 2.0.1
- Requires php-mbstring
- Requires php-zip

* Wed Nov 02 2011 dmorgan <dmorgan> 2.0.0-1.mga2
+ Revision: 161214
- New version 2

* Sun Oct 02 2011 dmorgan <dmorgan> 2.0.0-0.b3.1.mga2
+ Revision: 151109
- New version

* Sat Sep 24 2011 dmorgan <dmorgan> 2.0.0-0.b1.3.mga2
+ Revision: 147384
- Update to owncloud 2 beta 1

* Sun Sep 18 2011 dmorgan <dmorgan> 1.90.0-0.20110818.3.mga2
+ Revision: 145179
- Fix requires

* Sun Sep 18 2011 dmorgan <dmorgan> 1.90.0-0.20110818.2.mga2
+ Revision: 144707
- Fix sha1.lst
- Empty sha1.lst
- Change apache-conf require
- Add php-pear-MDB2_Driver_sqlite as suggests
- New git snapshot

* Mon Apr 04 2011 ennael <ennael> 1.1-1.mga1
+ Revision: 80479
- clean spec file
- imported package owncloud


* Fri Nov 26 2010 Funda Wang <fwang@mandriva.org> 1.1-1mdv2011.0
+ Revision: 601453
- 1.1 final

* Mon Aug 02 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.1-0.2mdv2011.0
+ Revision: 564901
- New snapshot

* Mon Jul 26 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.1-0.1mdv2011.0
+ Revision: 560853
- Update git snapshot ( pre 1.1 )

* Thu Apr 15 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.0-0.6mdv2010.1
+ Revision: 535024
- Update to new git snapshot

* Tue Mar 30 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.0-0.5mdv2010.1
+ Revision: 528969
- New owncloud snapshot

* Fri Mar 26 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.0-0.4.1mdv2010.1
+ Revision: 527607
- Change versionning
- Update owncloud snapshot

* Wed Mar 24 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 1.0-0.3f88fb9f.1mdv2010.1
+ Revision: 527202
- import owncloud


